### ===========================================================================
### -package  : simplepackageexample
#
package require SimpleDevLibPackage 1.0
declare-package {

   simplepackageexample

} -version {

   1.0

} -synopsis {

   A package example.

} -overview {

      Simple Development Library package example which implements a simple
   stack for integer numbers.

} -requisites {

   SimpleType
   SimpleError

} -namespaces {

   ::Stack
   ::Stack::Priv

} -type {

   {
      stackelement

   } -description {

      A stack element

   } -matchingscript {
      return [string is integer $value]
   }

} -variable {

   {
      ::Stack::TheStack

   } -description {

      The stack

   } -type {

      stackelement-list

   } -value {}

} -error {

   {
      ::Stack::NOT-A-VALID-ELEMENT

   } -message {

      not a valid stack element: %s

   } -explanation {

      This stack accepts integer elements only, but <bad element> is not an
      integer
   }

} -error {

   {
      ::Stack::EMPTY-STACK

   } -message {

      empty stack
   }

} -command {

   {
      ::Stack::push

   } -synopsis {

      Pushes an element onto the stack

   } -arguments {

      { element          stackelement   {The element}}

   } -returns {

      The empty string

   } -body {

      # Assert the element is valid
      ::Stack::Priv::assert-valid-element $element

      # Push the element onto the stack
      lappend ::Stack::TheStack $element

      # Return the empty string
      return {}
   }

} -command {

   {
      ::Stack::pop

   } -synopsis {

      Pops an element from the stack

   } -returns {

      The popped element

   } -body {

      # Assert the stack is not empty
      if {[llength $::Stack::TheStack] == 0} {
         ::Simple::Error::throw ::Stack::EMPTY-STACK
      }

      # Pop the element from the stack
      set answer [lindex $::Stack::TheStack end]
      set ::Stack::TheStack [lrange $::Stack::TheStack 0 end-1]

      # Return the popped element
      return $answer
   }

} -command {

   {
      ::Stack::Priv::assert-valid-element

   } -synopsis {

      Asserts an element is valid

   } -arguments {

      { element          stackelement   {The element}}

   } -body {

      # Invalid element
      if {![::Simple::Type::is stackelement $element]} {

         # Throw error
         ::Simple::Error::throw ::Stack::NOT-A-VALID-ELEMENT $element
      }
   }
}
